﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.IO;

namespace enMPacket
{
    public class MagickPacket
    {
        public static bool Send(byte [] MacAddr)
        {
            byte[] byts = new byte[6 + 6 * 16];
            if (MacAddr.Length != 6)
                return false;

            //頭に0xFFが６個
            for (int i = 0; i < 6; i++)
            {
                byts[i] = 0xFF;
            }

            //続いてMacアドレス（以下はtxtMac[i].TextにHex表記で６個入っている）
            //byte[] bytsMac = { 0x00, 0x1C, 0x7E, 0x31, 0xBA, 0x67 };

            //Macアドレスを１６回続けて入れる
            for (int i = 0; i < 16; i++)
            {
                Array.Copy(MacAddr, 0, byts, 6 + i * 6, 6);
            }

            //UDPのポート７（ECHO)にブロードキャスト
            IPEndPoint endPoint = new IPEndPoint(IPAddress.Parse("255.255.255.255"), 7);
            Socket sock = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
            sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, true);
            sock.SendTo(byts, endPoint);
            sock.Close();
            return true;
        }


        public static byte[] Parse(string MacStr)
        {
            byte[] ret = {0, 0, 0, 0, 0, 0};

            try
            {
                for (int i=0; i<6; i++)
                {
                    ret[i] = (byte)System.Convert.ToInt32(MacStr.Substring(i * 3, 2),16);
                }
            }
            catch (FormatException)
            {
                byte [] r = {0,0,0,0,0,0};
                return r;
            }                    
            return ret;
        }
    }

    static class Program
    {
        /// <summary>
        /// アプリケーションのメイン エントリ ポイントです。
        /// </summary>
        [STAThread]
        static void Main()
        {
            System.Reflection.Assembly asm = System.Reflection.Assembly.GetExecutingAssembly();
            string conffile = System.IO.Path.GetDirectoryName(asm.Location) + "\\"
                + System.IO.Path.GetFileNameWithoutExtension(Application.ExecutablePath) + ".config";
            
            string cmd = System.Environment.CommandLine;
            if (cmd.Contains("FILE=") && cmd.Contains("ID=") && File.Exists(conffile))
            {
                FileStream fs = new FileStream(conffile, FileMode.Open);
                StreamReader sr = new StreamReader(fs);
                string Mac = sr.ReadLine();
                sr.Close();
                MagickPacket.Send(MagickPacket.Parse(Mac));
           }
            else
            {
                Application.EnableVisualStyles();
                Application.SetCompatibleTextRenderingDefault(false);
                Application.Run(new Form1());
            }
        }
    }
}
